<template>
  <p>
    {{ etat }} le <time>{{ date }}</time> par <i>{{ utilisateur }}</i>
  </p>
</template>

<script>
import { DateTime } from 'luxon';

export default {
  name: 'MtAudit',
  props: {
    audit: {
      type: Object,
      required: true,
      default: () => ({}),
    },
  },
  computed: {
    etat() {
      if (this.audit.lastModifiedDate) {
        return 'Dernière modification';
      }
      return 'Crée';
    },
    date() {
      let date = '?';
      if (this.audit.lastModifiedDate) {
        date = this.createDate(this.audit.lastModifiedDate);
      } else if (this.audit.createdDate) {
        date = this.createDate(this.audit.createdDate);
      }
      return date;
    },
    utilisateur() {
      let utilisateur = '?';
      if (this.audit.lastModifiedDate) {
        utilisateur = this.createUtilisateur(this.audit.updatedBy, this.audit.lastModifiedByUsername);
      } else if (this.audit.createdDate) {
        utilisateur = this.createUtilisateur(this.audit.createdBy, this.audit.createdByUsername);
      }
      return utilisateur;
    },
  },
  methods: {
    createDate(date) {
      return DateTime.fromISO(date)
        .setLocale('fr')
        .toFormat('dd/MM/yyyy à HH:mm');
    },
    createUtilisateur({ nom, prenom }, username) {
      if (nom && prenom) {
        return `${nom} ${prenom}`;
      }
      return username;
    },
  },
};
</script>

<style scoped lang="scss">
p {
  font-size: 0.6875rem;
  color: #aaa;
  text-align: right;
  cursor: default;
  margin-top: 2rem;
}
</style>
